#include <iostream.h>

class BaseClass {
public:
    BaseClass() { }
    void f(char *s = "nieznany") {
        cout << "Funkcja f() w BaseClass wywoana z " << s << endl;
        h();
    }
protected:
    void g(char *s = "nieznany") {
        cout << "Funkcja g() w BaseClass wywoana z " << s << endl;
    }
private:
    void h() {
        cout << "Funkcja h() w BaseClass\n";
    }
};
class Derived1Level1 : public virtual BaseClass {
public:
    void f(char *s = "nieznany") {
        cout << "Funkcja f() w Derived1Level1 wywoana z " << s << endl;
        g("Derived1Level1");
        h("Derived1Level1");
    }
    void h(char *s = "nieznany") {
        cout << "Funkcja h() w Derived1Level1 wywoana z " << s << endl;
    }
};
class Derived2Level1 : public virtual BaseClass {
public:
    void f(char *s = "nieznany") {
        cout << "Funkcja f() w Derived2Level1 wywoana z " << s << endl;
        g("Derived2Level1");
//      h();  // bd: BaseClass::h() jest niedostpna
    }
};
class DerivedLevel2 : public Derived1Level1, public Derived2Level1 {
public:
void f(char *s = "nieznany") {
	cout << "Funkcja f() w DerivedLevel2 wywoana z " << s << endl;
	g("DerivedLevel2"); 
	Derived1Level1::h("DerivedLevel2");
	BaseClass::f("DerivedLevel2");
    }
};

void main() {
    BaseClass bc;
    Derived1Level1 d1l1;
    Derived2Level1 d2l1;
    DerivedLevel2 dl2;
    bc.f("main(1)");
//  bc.g(); // bd: BaseClass::g() jest niedostpna
//  bc.h(); // bd: BaseClass::h() jest niedostpna
    d1l1.f("main(2)");
//  d1l1.g(); // bd: BaseClass::g() jest niedostpna
    d1l1.h("main(3)");
    d2l1.f("main(4)");
//  d2l1.g(); // bd: BaseClass::g() jest niedostpna
//  d2l1.h(); // bd: BaseClass::h() jest niedostpna
    dl2.f("main(5)");
//  dl2.g();  // bd: BaseClass::h() jest niedostpna
    dl2.h();
}

